<template>
    <div class="dropdown" :class="{ open: showMenu }">
      <!-- Always visible section -->
      <div class="select" @click="toggleMenu">
        <span class="label">{{ title }}</span>
        <span v-if="!showMenu" class="value"><span class="symbol" v-if="oneLevel && selectedSymbol">{{ selectedSymbol }}</span>{{ selectedOperand }}</span>
        <button class="dropdown-toggle"><i class="icon-arrow-down"></i></button>
      </div>
  
      <!-- Dropdown menu -->
      <div v-if="showMenu" class="menu">
        <!-- Dropdown with one level -->
        <div v-if="oneLevel">
          <div :class="['menu-item', { selected: selectedItemId === item.id }]" v-for="item in oneLevelMenuItems" :key="item.id">
            <button @click="handleClick(item)">
              <span class="symbol">{{ item?.symbol }}</span>{{ item.label }}
            </button>
          </div>
        </div>
        <!-- Dropdown with multiple levels -->
        <div v-else>
          <button v-if="menuHistory.length > 0" class="back-button" @click="goBack">Back</button>
          <div :class="['menu-item', { submenu: menuHistory.length > 0, selected: selectedItemId === item.id }]" v-for="item in activeMenu" :key="item.id">
            <button @click="handleClick(item)">
              {{ item.label }}
            </button>
          </div>
        </div>
        
      </div>
    </div>
</template>

<script setup lang="ts">

// Define the menu item structure
interface MenuItem {
  id: number;
  label: string;
  submenu?: MenuItem[];
}

interface MenuOneLevel {
  id: number;
  label: string;
  symbol: string;
}

const props = defineProps<{
  menu: MenuItem[] | MenuOneLevel[];  // Allow both types
  initialLabel?: string;
  title?: string;
  oneLevel?: boolean;
}>();

const emit = defineEmits(['selection']);

const menuItems = computed(() => props.menu as MenuItem[]);
const oneLevelMenuItems = computed(() => props.menu as MenuOneLevel[]);

const activeMenu = ref<MenuItem[]>(props.menu);
const menuHistory = ref<MenuItem[][]>([]);
const selectedOperand = ref(props.initialLabel);
const selectedSymbol = ref<string | null>(null);
const showMenu = ref(false);
const selectedItemId = ref<number | null>(null);

const toggleMenu = () => {
    showMenu.value = !showMenu.value;
};

const handleClick = (item: MenuItem) => {
    if (item.submenu) {
        // Navigate to submenu without closing the menu
        menuHistory.value.push(activeMenu.value);
        activeMenu.value = item.submenu;
    } else {
        // Select the item and close the menu
        selectedOperand.value = item.label;
        if(props.oneLevel) {
          selectedSymbol.value = (item as MenuOneLevel).symbol;
        }
        selectedItemId.value = item.id;
        emit("selection", item); // Emit the selected item to the parent
        showMenu.value = false;
        menuHistory.value = []; // Reset the menu history
        activeMenu.value = props.menu; // Reset to the main menu
    }
};

const goBack = () => {
    if (menuHistory.value.length > 0) {
        activeMenu.value = menuHistory.value.pop()!;
    }
};

</script>